# defines '#" as comment character
# file icereg6a.r  --- -- last change 11/8/2015
#  Ian Enting, MASCOS, The University of Melbourne
#  ian.g.enting@gmail.com
# addiitional comments added 18/6/16 to create icereg6b.r
# Code history icereg6(a).r <  icereg5.r < icereg4.r <  icereg3.r < icereg2.r <- icereg.r <  moberg .r
# Run as source("icereg6b.R")   after  setwd(".......")  (or equivalent)
comment.char <- '#'
#...................................................................................
#   Explore (and plot) proposed relations between temperature and CO2
#        (and create functions and data sets that can be used in interactive mode)
#                                           CO2 in ppm
# .........................................................................................................
  rm( list=ls() )  #  Remove all old objects 
           #(e.g. protects against typos  picking up  obsolete stuff  from earlier runs)
# .........................................................................................................
#                                         TO DO
#  Include PAGES
#.................................................................................... Set up plot
source("u_disp.R") # This is the ONLY change in the code in going from icereg6a to icereg6b
# source("../udisp/u_disp.R")
fname = "newfit1.eps"   # CHANGE FILE NAME AS REQUIRED
nc =0    # 0 for window, 1 for use filename
init_disp(nc, fname) 
set_box0()               # IGE defaults (defined in u_disp.r) for label offset etc
xlab1 = "Year "
ylab1 = "CO2 from Temperature anomaly"
xlim1 = c(900,1800) ; ylim1 = c(270,300) #........... SELECT PLOT RANGE -- EDIT VALUES AS REQUIRED
# xlim1 = c(500,1800);   ylim1 = c(-10,10)  # For Rubino paper
 plot(c(0),type="n",xlab=xlab1,ylab=ylab1,xlim=xlim1,ylim=ylim1,xaxs = "i",yaxs = "i")
#
Tref <- c(1:2000)                                       # Structure into which to write 
#...................................................................................... Read data
# temp1 <- read.table("moberg.txt",header=TRUE);  Ttmax =1979 # From early stage of development

co2all <- read.table("CO2_DSS_DE08.txt",header=TRUE)
# Define ftting interval
#tf1 = 1500; tf2 = 1800
 tf1 = 1000; tf2 = 1750
# tf1 = 500; tf2 = 1750
# tf1 = 1300; tf2 = 1750  # ************************************************* SELECT RANGE  OF CO2 TO FIT ***********
fitCO2x <- co2all$CO2[ co2all$Year < tf2]
fitTimex <- co2all$Year[ co2all$Year < tf2]
fitCO2  <- fitCO2x[fitTimex > tf1]
fitTimes  <- fitTimex[fitTimex > tf1]
ndat <- length(fitCO2)
#   Read and integrate anthropogenic emissions (convert Mt to ppm)
Ttmax = 2000
source("ar_foss1.r")
source("ar_lucf1.r")
#source("../u-yr-data/ar_foss1.r")
#source("../u-yr-data/ar_lucf1.r")
Tintanth <- Tref * 0                                           # sets size of vector
for (j in 1: (Ttmax-1750)) {
   Tintanth[j+1750] <- Tintanth[j+1749] + f1_cdiac[j]*0.471/1000.0  +
 j*ar_lucf1[1]*0.471/1000.0/100.0  # Linear back extrapolation 1850 to 1750
}
for (j in 1: (Ttmax-1850)) {
   Tintanth[j+1850] <- Tintanth[j+1849] + (f1_cdiac[j+100]+ar_lucf1[j]) * 0.471/1000.0
}

# .............................................................................. Smooth temperatures

Esmoothx <- function(Tdat, tau,offset,t1,t2) { 
      Tx <-  Tref * 0.0;        # 
      Tx[t1]= Tdat[1]
      for(j in t1+1 : t2)
           { Tx[j] <- (Tdat[j-t1+1] +offset)/tau + Tx[j-1]*(1.0- 1.0/tau)}
      Tx  # this is what the function returns
}

Econv <- function(Tdat, tau,offset,t1,t2) { 
      Tx <-  Tref * 0.0;        # 
      Tx[t1]= Tdat[1]
      for(j in t1+1 : t2)
           { Tx[j] <- (Tdat[j-t1+1] +offset) + Tx[j-1]*(1.0- 1.0/tau)}
      Tx  # this is what the function returns
}

# Double convolution
Econv2 <- function(Tdat, tau1,tau2, offset, t1, t2) { 
      Tx1 <-  Tref*0.0;  Tx2 <- Tref* 0.0       # 
       r1 = 1/tau1; r2 = 1/tau2
      Tx1[t1]= Tdat[1] ; Tx2[t1]= Tdat[1]
      for(j in t1+1 : t2)
           { Tx1[j] <- (Tdat[ j-t1+1] +offset) + Tx1[j-1]*(1.0 - 1.0/tau1)
             Tx2[j] <- (Tdat[j-t1+1] +offset) + Tx2[j-1]*(1.0  - 1.0/tau2)
            }
      Tx <- (r1 * Tx1 - r2*Tx2)/(r1 - r2)
      Tx  # this is what the function returns
}

#  Note that "offset" will affect the transient and the intercept of a regression,
#   but doesn't affect the regression coefficients of  predictors
#         (and doesn't have to be the same for all predictors)
#  

# Generic code

#                                                       Generic subset procedure
SubsetT <- function(xTimes,ndat,TR,Ttmin){
       XX <-  xTimes;
       for (j in 1:ndat) {   k <- xTimes[j]
            XX[j] <- TR[k]
            }   
       XX   # data set returned
}

#                                                     Generic fit a transformed T series
FitCase <- function(fileT, Ttmin,Ttmax, Ttr, Col, Lty){
  #  ** Read temperature data
         temp1 <- read.table(fileT,header=TRUE);  
         print(c("Temperature data from: ",fileT, Col, "linetype=", Lty))
       #   lines(temp1$year, temp1$temp)  #  Plot Temperature data
  #  Transform temperature data
          TR <- Ttr(temp1$temp,Ttmin,Ttmax)
  #   Subset transformed temperature data
            XTR <- SubsetT(fitTimes,ndat, TR,Ttmin)
  #  Perform regression
           fm2 <- lm(fitCO2~XTR)
           #  print(fm2)
           CC <- fm2$coefficients
           print(c("coefficients",CC))
  #   Construct fit
          FITa <- CC[1]+ CC[2]*TR # + 0.436*Tintanth
          FIT <- FITa [Ttmin:Ttmax]
          TIMES = Tref[Ttmin:Ttmax]
  #   Plot fit
          lines(TIMES, FIT, col=Col, lty=Lty)
fm2 #   return "model" object that can be explored in console mode  # Added in version 6a
#  icereg6 used a number of global assignments ( <<-) for debugging purposes
}

#  Code multiple versions of transformation

# Dummy, mainly for code development
Ttrans <- function(TT, t1, t2){
    print("Smoothing function: Identity as dummy")
    TT  # dummy
    }

# Exponential smoothing: mimic Bauska
TransBauska <- function(TT, t1,t2){
    print(c("Smoothing function: Exponential tau = ",tauBauska))
    TX <- Esmoothx(TT,tauBauska, 0.3, t1,t2) 
    }

# This was an exploratory case from the period when formalsim was being developed
TransEM <- function(TT, t1,t2){
    print("Smoothing function: Enting/Mansbridge approx")
# Approximation of  R from Enting and Mansbridge 87 includes the Gt to ppm conversion
    TX1 <- Esmoothx(TT,10.0, 0.3, t1,t2) 
    TX2 <- Esmoothx(TT,300.0, 0.3, t1,t2) 
    TX = 0.17575*TX1*10 + 0.294*TX2*300
     }

TransBernFB <- function(TT, t1, t2){
    tauFB = 100.0  #************************************************* SELECT TIMESCALE IN ENTING FORMALISM
    print(c("Smoothing function: Bern model convoled with FB response",
    tauFB, " years")) 
    Tx0 <- Econv(TT, tauFB, 0.3, t1, t2)     
    Tx1 <- Econv2(TT, tauFB, 1.186, 0.3, t1,t2)
    Tx2 <- Econv2(TT, tauFB, 18.51, 0.3, t1,t2)
    Tx3 <- Econv2(TT, tauFB, 172.9, 0.3, t1,t2)
    TX <- (0.217*Tx0+ 0.186*Tx1 + 0.338*Tx2+ 0.259*Tx3)*0.471 
    }

TransJoosFB <- function(TT, t1, t2){
    tauFB = 100.0  #********************************* SELECT TIMESCALE IN ENTING FEEDBACK FORMALISM
    print(c("Smoothing function: Joos 2013 response convoled with FB response",
    tauFB, " years")) # Table 5 in ACP paper.
    Tx0 <- Econv(TT, tauFB, 0.3, t1, t2)     
    Tx1 <- Econv2(TT, tauFB, 394.4, 0.3, t1,t2)
    Tx2 <- Econv2(TT, tauFB, 36.54, 0.3, t1,t2)
    Tx3 <- Econv2(TT, tauFB, 4.303, 0.3, t1,t2)
    TX <- (0.2173*Tx0+ 0.224*Tx1 + 0.2824*Tx2+ 0.2783*Tx3)*0.471
    }



tauBauska <- 100  # ************************************* IF EMULATING BAUSKA SELECT TAU
Ttrans <- function(TT, t1, t2){
#   TransBernFB(TT, t1, t2)
     TransJoosFB(TT, t1, t2)
#    TransEM(TT, t1, t2)
#    TransBauska(TT, t1, t2)
     }

# ....................................... Choices of actual runs
print(c("Fitting CO2 data over period: ",tf1,tf2,": ",ndat,"data points"))
# 2nd and 3rd arguments (dates, AD) depend on data set used
XX <-   FitCase("moberg.txt",   1, 1979, Ttrans, "blue",   1)
XX <-   FitCase("mann.txt", 500, 2000, Ttrans, "black", 3)
XX <-   FitCase("CandL12.txt", 1, 1973, Ttrans, "black", 2)
XX <-   FitCase("PAGES_ARCTIC.txt",   1, 2000, Ttrans, "green",   1)
#XX  <-   FitCase("PAGES_ASIA.txt",   800, 1989, Ttrans, "red",   3)
# XX <-   FitCase("PAGES_EUROPE.txt",   1, 2003, Ttrans, "red",   2)

points(co2all$Year, co2all$CO2 ,col="red")  # Overplot with all CO2 data

#         add a legend if desired
#   legend(x="topleft",c("1956","1976","2010", "2011"),col=c("green","red","blue", "black"),pch = c(1, 3,4,19))
#
#
PlotOne <- function(C0,A, Xpred){                     # To be called from interactive mode
   plot(c(0),type="n",xlab=xlab1,ylab=ylab1,xlim=xlim1,ylim=ylim1,xaxs = "i",yaxs = "i")
 #  lines(temp1$year, C0+A*Xpred +0.436*Tintanth, col="black")   
   points(co2all$Year, co2all$CO2 - 280,col="red")
}
#
end_disp(nc)                      # Closes eps file if appropriate
#